"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class PackageManagerCommand {
    constructor($userSettingsService, $errors, $stringParameter) {
        this.$userSettingsService = $userSettingsService;
        this.$errors = $errors;
        this.$stringParameter = $stringParameter;
        this.allowedParameters = [this.$stringParameter];
    }
    execute(args) {
        if (args[0] === 'yarn') {
            return this.$userSettingsService.saveSetting("packageManager", "yarn");
        }
        else if (args[0] === 'npm') {
            return this.$userSettingsService.saveSetting("packageManager", "npm");
        }
        return this.$errors.fail(`${args[0]} is not a valid package manager. Only yarn or npm are supported.`);
    }
}
exports.PackageManagerCommand = PackageManagerCommand;
$injector.registerCommand("package-manager|set", PackageManagerCommand);
