"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const util_1 = require("util");
const helpers_1 = require("../../helpers");
const constants_1 = require("../../../constants");
const os_1 = require("os");
function layout(config) {
    return function (logEvent) {
        let msg = util_1.format.apply(null, logEvent.data);
        if (logEvent.context[constants_1.LoggerConfigData.wrapMessageWithBorders]) {
            msg = helpers_1.getMessageWithBorders(msg);
        }
        if (!logEvent.context[constants_1.LoggerConfigData.skipNewLine]) {
            msg += os_1.EOL;
        }
        if (logEvent.level.isEqualTo(constants_1.LoggerLevel.INFO)) {
            return msg;
        }
        if (logEvent.level.isEqualTo(constants_1.LoggerLevel.ERROR)) {
            return msg.red.bold;
        }
        if (logEvent.level.isEqualTo(constants_1.LoggerLevel.WARN)) {
            return msg.yellow;
        }
        return msg;
    };
}
exports.layout = layout;
