"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const build_data_1 = require("../data/build-data");
class BuildDataService {
    constructor($mobileHelper) {
        this.$mobileHelper = $mobileHelper;
    }
    getBuildData(projectDir, platform, data) {
        if (this.$mobileHelper.isiOSPlatform(platform)) {
            return new build_data_1.IOSBuildData(projectDir, platform, data);
        }
        else if (this.$mobileHelper.isAndroidPlatform(platform)) {
            return new build_data_1.AndroidBuildData(projectDir, platform, data);
        }
    }
}
exports.BuildDataService = BuildDataService;
$injector.register("buildDataService", BuildDataService);
