"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class DebugDataService {
    constructor($devicesService) {
        this.$devicesService = $devicesService;
    }
    getDebugData(deviceIdentifier, projectData, debugOptions) {
        const device = this.$devicesService.getDeviceByIdentifier(deviceIdentifier);
        return {
            applicationIdentifier: projectData.projectIdentifiers[device.deviceInfo.platform.toLowerCase()],
            projectDir: projectData.projectDir,
            deviceIdentifier,
            projectName: projectData.projectName,
            debugOptions
        };
    }
}
exports.DebugDataService = DebugDataService;
$injector.register("debugDataService", DebugDataService);
