"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const ora = require("ora");
class TerminalSpinnerService {
    createSpinner(spinnerOptions = {}) {
        spinnerOptions.stream = spinnerOptions.stream || process.stdout;
        return new ora(spinnerOptions);
    }
    execute(spinnerOptions, action) {
        return __awaiter(this, void 0, void 0, function* () {
            const spinner = this.createSpinner(spinnerOptions);
            spinner.start();
            let result = null;
            try {
                result = yield action();
            }
            catch (err) {
                spinner.fail();
                return null;
            }
            spinner.succeed();
            return result;
        });
    }
}
exports.TerminalSpinnerService = TerminalSpinnerService;
$injector.register('terminalSpinnerService', TerminalSpinnerService);
